VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form frmMain 
   Caption         =   "ThermochronDumpMission"
   ClientHeight    =   3645
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   4350
   LinkTopic       =   "Form1"
   ScaleHeight     =   3645
   ScaleWidth      =   4350
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton GetTemperatureLog 
      Caption         =   "&Get Temperature Log"
      Height          =   375
      Left            =   360
      TabIndex        =   2
      Top             =   0
      Width           =   1695
   End
   Begin MSFlexGridLib.MSFlexGrid grid 
      Height          =   2775
      Left            =   120
      TabIndex        =   1
      Top             =   360
      Width           =   3975
      _ExtentX        =   7011
      _ExtentY        =   4895
      _Version        =   393216
      FixedCols       =   0
      AllowUserResizing=   1
   End
   Begin MSComDlg.CommonDialog dlgCommonDialog 
      Left            =   5400
      Top             =   4800
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin MSComctlLib.StatusBar sbStatusBar 
      Align           =   2  'Align Bottom
      Height          =   270
      Left            =   0
      TabIndex        =   0
      Top             =   3375
      Width           =   4350
      _ExtentX        =   7673
      _ExtentY        =   476
      _Version        =   393216
      BeginProperty Panels {8E3867A5-8586-11D1-B16A-00C0F0283628} 
         NumPanels       =   3
         BeginProperty Panel1 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
            AutoSize        =   1
            Text            =   "Status"
            TextSave        =   "Status"
         EndProperty
         BeginProperty Panel2 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
            Style           =   6
            AutoSize        =   2
            TextSave        =   "1/8/03"
         EndProperty
         BeginProperty Panel3 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
            Style           =   5
            AutoSize        =   2
            TextSave        =   "2:59 PM"
         EndProperty
      EndProperty
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

''''''''''''''''''''''''''
' Necessary declarations
''''''''''''''''''''''''''
Private Type SYSTEMTIME
   wYear         As Integer
   wMonth        As Integer
   wDayOfWeek    As Integer
   wDay          As Integer
   wHour         As Integer
   wMinute       As Integer
   wSecond       As Integer
   wMilliseconds As Integer
End Type

Private Type TIME_ZONE_INFORMATION
   Bias As Long
   StandardName(0 To ((32 * 2) - 1)) As Byte
   StandardDate As SYSTEMTIME
   StandardBias As Long
   DaylightName(0 To ((32 * 2) - 1)) As Byte
   DaylightDate As SYSTEMTIME
   DaylightBias As Long
End Type

Private Declare Function GetTimeZoneInformation Lib "kernel32" _
    (lpTimeZoneInformation As TIME_ZONE_INFORMATION) As Long

'Global Var
Dim access As OneWireAccessProvider

Private Sub Form_Load()
    Me.Left = GetSetting(App.Title, "Settings", "MainLeft", 1000)
    Me.Top = GetSetting(App.Title, "Settings", "MainTop", 1000)
    Me.Width = GetSetting(App.Title, "Settings", "MainWidth", 6500)
    Me.Height = GetSetting(App.Title, "Settings", "MainHeight", 6500)

    Set access = New owapi.OneWireAccessProvider

    grid.ColWidth(0) = 2100
    grid.ColWidth(1) = 1100
    grid.Col = 0
    grid.Row = 0
    grid.Text = "Time"
    grid.Col = 1
    grid.Text = " Deg. Celsius"
    grid.Redraw = True
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Dim i As Integer


    'close all sub forms
    For i = Forms.Count - 1 To 1 Step -1
        Unload Forms(i)
    Next
    If Me.WindowState <> vbMinimized Then
        SaveSetting App.Title, "Settings", "MainLeft", Me.Left
        SaveSetting App.Title, "Settings", "MainTop", Me.Top
        SaveSetting App.Title, "Settings", "MainWidth", Me.Width
        SaveSetting App.Title, "Settings", "MainHeight", Me.Height
    End If
End Sub

Private Sub GetTemperatureLog_Click()
    Dim adapter As Object
    Dim owc As OneWireContainer21

    Dim state As Object, log As Object
    Dim rate As Integer
    Dim timeStamp As Date, timeVal As Date

    Set adapter = access.getDefaultAdapter()
    adapter.targetFamily (&H21)
    adapter.beginExclusive (True)
    adapter.Reset
    adapter.setSearchAllDevices

    If adapter.findFirstDevice Then
        Set owc = New OneWireContainer21
        owc.setupContainer adapter, adapter.getAddressAsString()

        Set state = owc.readDevice()
        timeStamp = UnixTimeToVBDate(owc.getMissionTimeStamp(state))
        offset = (owc.getFirstLogOffset(state)) / 60000
        firstTime = DateAdd("n", offset, timeStamp)
        rate = CInt(owc.getSampleRate(state))
        Set log = owc.GetTemperatureLog(state)
        If log.getSize() > 0 Then
            Dim i
            grid.Rows = log.getSize() + 1
            For i = 0 To (log.getSize() - 1)
                timeVal = DateAdd("n", i * rate, firstTime)
                grid.Col = 0
                grid.Row = i + 1
                grid.Text = timeVal
                grid.Col = 1
                grid.Text = owc.decodeTemperature(log.getAt(i))
            Next
        End If
    Else
        MsgBox ("No Thermochron devices found")
    End If

    'end exclusive use
    adapter.endExclusive
    adapter.freePort

End Sub


Private Sub mnuFileExit_Click()
    'unload the form
    Unload Me

End Sub

''''''''''''''''''''''''''
' Helper functions
''''''''''''''''''''''''''
'Convert the current time in milliseconds to a VB Date format
Private Function UnixTimeToVBDate(UnixTime As String) As Date
    Dim Seconds As Long
    Seconds = Left(UnixTime, Len(UnixTime) - 3)
    UnixTimeToVBDate = DateAdd("s", Seconds, GetBeginningOfTime())
End Function

'Convert the current time to the number of milliseconds since
' Jan 1, 1970 00:00:00 GMT
Private Function VBDateToUnixTime(vbDate As Date) As String
    Dim UnixTime As String
    UnixTime = DateDiff("s", GetBeginningOfTime(), vbDate)
    VBDateToUnixTime = UnixTime & "000"
End Function

'This function returns the Unix standard beginning of time
'  Jan 1, 1970 00:00:00 GMT
'But adjusted to your timezone.
Private Function GetBeginningOfTime()
    Dim tz As TIME_ZONE_INFORMATION

    Select Case GetTimeZoneInformation(tz)
        Case 0:
            'Unknown, Go ahead and send GMT
            GetBeginningOfTime = #1/1/1970#
        Case 1:
            'Standard time
            GetBeginningOfTime = DateAdd("n", _
                        -(tz.Bias + tz.StandardBias), #1/1/1970#)
        Case 2:
            'Daylight Saving time
            GetBeginningOfTime = DateAdd("n", _
                        -(tz.Bias + tz.DaylightBias), #1/1/1970#)
    End Select
End Function


